unit hiCounterEx;

interface

uses Kol,Share,Debug;

type
  THICounterEx = class(TDebug)
   private
     FCounterEx:integer;
     FFirst:boolean;
   public
    _prop_Min:integer;
    _prop_Max:integer;
    _prop_Step:integer;
    _prop_Type:byte;
    _data_Min:THI_Event;
    _data_Max:THI_Event;
    _data_Step:THI_Event;    
    _event_onNext:THI_Event;
    _event_onLoop:THI_Event;

    constructor Create;
    procedure _work_doNext(var _Data:TData; Index:word);
    procedure _work_doPrev(var _Data:TData; Index:word);
    procedure _work_doReset(var _Data:TData; Index:word);
    procedure _work_doMax(var _Data:TData; Index:word);
    procedure _work_doMin(var _Data:TData; Index:word);
    procedure _work_doValue(var _Data:TData; Index:word);
    procedure _work_doStep(var _Data:TData; Index:word);
    procedure _work_doType(var _Data:TData; Index:word);    
    procedure _var_Count(var _Data:TData; Index:word);
    property _prop_Default:integer write FCounterEx;
  end;

implementation

constructor THICounterEx.Create;
begin
   inherited Create;
   FFirst := true;
end;

procedure THICounterEx._work_doNext;
begin  
	//dt := _Data;

	{
   if FFirst then
    begin
     FCounterEx := _prop_Default;
     FFirst := false;
    end;
   }
   if _prop_Type = 0 then
    begin
     inc(FCounterEx,_prop_Step);
     if FCounterEx > _prop_Max then
        begin
          FCounterEx := _prop_Min;
          _hi_OnEvent(_event_onLoop,_Data);
        end   
    end
   else
    begin
     dec(FCounterEx,_prop_Step);
     if FCounterEx < _prop_Min then
        begin
           FCounterEx := _prop_Max;
            _hi_OnEvent(_event_onLoop,_Data);
        end          
    end;
               
    _hi_CreateEvent(_Data,@_event_onNext,FCounterEx);

end;

procedure THICounterEx._work_doPrev;
var old:byte;
begin
   old := _prop_Type;
   _prop_Type := integer(not boolean(old));
  _work_doNext(_Data,Index);
  _prop_Type := old;
end;

procedure THICounterEx._work_doReset;
begin
   if _prop_Type = 0 then
      FCounterEx := _prop_Min
   else FCounterEx := _prop_Max;
end;

procedure THICounterEx._work_doValue;
begin
  FCounterEx := ToInteger(_Data);
end;

procedure THICounterEx._work_doMax;
begin
    _prop_Max := ReadInteger(_Data,_data_Max,0);
end;

procedure THICounterEx._work_doMin;
begin
    _prop_Min := ReadInteger(_Data,_data_Min,0);
end;

procedure THICounterEx._work_doStep;
begin
    _prop_Step := ReadInteger(_Data,_data_Step,0);
end;

procedure THICounterEx._work_doType;
begin
  _prop_Type := Byte(ToInteger(_Data));
end;

procedure THICounterEx._var_Count;
begin
    dtInteger(_Data,FCounterEx);
end;

end.
